program DCallyDemo;

// Delphi 6PE port of Cal3D (C) 2001 Paul TOTH <tothpaul@free.fr>
// Cal3D-0.6 (4. Aug. 2001) (C) 2001 Bruno 'Beosil' Heidelberger

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{$apptype console}

{$define debug}

uses
  Windows,
  SysUtils,
  Classes,
  Menu in 'Menu.pas',
  Demo in 'Demo.pas',
  Model in 'Model.pas',
  DCal3D in 'DCal3D.pas',
  DelphiGL in 'DelphiGL.pas';

{$R *.res}

Var
 argc:integer;

var
 idlemax:integer;

procedure idleFunc; cdecl;
 var
  t:integer;
 begin
  t:=GetTickCount;
  TheDemo.OnIdle;
  t:=GetTickCount-t;
  if t>=idlemax then begin
   writeln(#174'idleFunc ',t,' ms'#175);
   idlemax:=t;
  end;
 end;

var
 mousemax:integer;
procedure mouseFunc(button,state,x,y:integer); cdecl;
 var
  t:integer;
 begin
  t:=getTickCount;
  // redirect the message to the demo instance
  if (state = GLUT_DOWN) then begin
    theDemo.onMouseButtonDown(button, x, theDemo.Height - y - 1);
  end
  else if (state = GLUT_UP) then begin
    theDemo.onMouseButtonUp(button, x, theDemo.Height - y - 1);
  end;
  t:=getTickCount-t;
  if (t>0)and(t>mousemax) then begin
   writeln(#174'mouseFunc ',t,' ms'#175);
   mousemax:=t;
  end;
end;

var
 motionMax:integer;
procedure motionFunc(x,y:integer); cdecl;
 var
  t:integer;
 begin
  t:=GetTickCount;
  // redirect the message to the demo instance
  theDemo.onMouseMove(x, theDemo.Height - y - 1);
  t:=GetTickCount-t;
  if (t>=motionMax)and(t>0) then begin
   writeln(#174'motionFunc ',t,' ms'#175);

   motionmax:=t;

  end;

 end;

procedure reshapeFunc(width, height:integer); cdecl;
 begin
 {$ifdef debug}writeln(#174'reshapeFunc'#175);{$endif}
  // set the new width/height values
  theDemo.setDimension(width, height);
 end;

var
 displaymax:integer;
procedure displayFunc; cdecl;
 var
  t:integer;
 begin
  t:=GetTickCount;
  // render the scene
  theDemo.onRender;
  t:=GetTickCount-t;
  if t>displaymax then begin
   writeln(#174'displayFunc ',t,' ms'#175);
   displaymax:=t;
  end;
 end;

procedure keyboardFunc(key:char; x,y:integer); cdecl;
 begin
 {$ifdef debug}writeln(#174'keyboardFunc'#175);{$endif}
  // redirect the message to the demo instance
  theDemo.onKey(key, x, theDemo.Height - y - 1);
 end;



begin

  // initialize the GLUT system
  argc:=ParamCount+1;
  glutInit(argc,CmdLine);

  // create our demo instance
  TheDemo:=TDemo.Create;

  // register our own exit callback
 // atexit(exitFunc);

  // set all GLUT modes
  glutInitDisplayMode(GLUT_DOUBLE or GLUT_RGB or GLUT_DEPTH);
  glutInitWindowSize(theDemo.Width, theDemo.Height);
  glutCreateWindow('- Cal3D The Cally Demo -');
  if (theDemo.Fullscreen) then glutFullScreen;
  glutSetCursor(GLUT_CURSOR_NONE);

  // register all GLUT callback functions
  glutIdleFunc(@idleFunc);
  glutMouseFunc(@mouseFunc);
  glutMotionFunc(@motionFunc);
  glutPassiveMotionFunc(@motionFunc);
  glutReshapeFunc(@reshapeFunc);
  glutDisplayFunc(@displayFunc);
  glutKeyboardFunc(@keyboardFunc);

  // initialize our demo instance
  if(theDemo.onInit=false) then begin
    writeln('Initialization of the demo failed.');
    halt;
  end;

  // run the GLUT message loop
  glutMainLoop();

end.
